; Atari 7800 Taquart Intro
; Code by Heaven/TQA
; Music RMT Player by Raster & Eckhard Stollberg (7800) music not implemented yet
; gfx by Heaven

;coded 12th january 2004

; gfx converted with custom turbo basic XL program on atari 8bit

; Atari 7800 code framework
; Written by Daniel Boris (dboris@home.com)
;
; Assemble with DASM
;

;this intro shows 8 32x32x4 sprites swinging on screen. each with its own palette so
;you'll see 24 colors on screen & per scanline. this is not possible on
;Atari computers in that way.
;
;I hope it helps a lot of people kicking of some stuff on a7800...
;
;intro was tested in mess emulator only.
;
;suggestions: heaven_tqa@hotmail.com or at www.atariage.com
;


	processor 6502

; ************ Hardware Adresses ***************************

INPTCTRL        equ     $01     ;Input control
AUDC0           equ     $15     ;Audio Control Channel 0
AUDC1           equ     $16     ;Audio Control Channel 1
AUDF0           equ     $17     ;Audio Frequency Channel 0
AUDF1           equ     $18     ;Audio Frequency Channel 1
AUDV0           equ     $19     ;Audio Volume Channel 0
AUDV1           equ     $1A     ;Audio Volume Channel 1
INPT0           equ     $08     ;Paddle Control Input 0
INPT1           equ     $09     ;Paddle Control Input 1
INPT2           equ     $0A     ;Paddle Control Input 2
INPT3           equ     $0B     ;Paddle Control Input 3
INPT4           equ     $0C     ;Player 0 Fire Button Input
INPT5           equ     $0D     ;Player 1 Fire Button Input

BACKGRND        equ     $20     ;Background Color
P0C1            equ     $21     ;Palette 0 - Color 1
P0C2            equ     $22     ;Palette 0 - Color 2
P0C3            equ     $23     ;Palette 0 - Color 3
WSYNC           equ     $24     ;Wait For Sync
P1C1            equ     $25     ;Palette 1 - Color 1
P1C2            equ     $26     ;Palette 1 - Color 2
P1C3            equ     $27     ;Palette 1 - Color 3
MSTAT           equ     $28     ;Maria Status
P2C1            equ     $29     ;Palette 2 - Color 1
P2C2            equ     $2A     ;Palette 2 - Color 2
P2C3            equ     $2B     ;Palette 2 - Color 3
DPPH            equ     $2C     ;Display List List Pointer High
P3C1            equ     $2D     ;Palette 3 - Color 1
P3C2            equ     $2E     ;Palette 3 - Color 2
P3C3            equ     $2F     ;Palette 3 - Color 3
DPPL            equ     $30     ;Display List List Pointer Low
P4C1            equ     $31     ;Palette 4 - Color 1
P4C2            equ     $32     ;Palette 4 - Color 2
P4C3            equ     $33     ;Palette 4 - Color 3
CHARBASE        equ     $34     ;Character Base Address
P5C1            equ     $35     ;Palette 5 - Color 1
P5C2            equ     $36     ;Palette 5 - Color 2
P5C3            equ     $37     ;Palette 5 - Color 3
OFFSET          equ     $38     ;Unused - Store zero here
P6C1            equ     $39     ;Palette 6 - Color 1
P6C2            equ     $3A     ;Palette 6 - Color 2
P6C3            equ     $3B     ;Palette 6 - Color 3
CTRL            equ     $3C     ;Maria Control Register
P7C1            equ     $3D     ;Palette 7 - Color 1
P7C2            equ     $3E     ;Palette 7 - Color 2
P7C3            equ     $3F     ;Palette 7 - Color 3

SWCHA           equ     $280    ;P0, P1 Joystick Directional Input
SWCHB           equ     $282    ;Console Switches
CTLSWA          equ     $281    ;I/O Control for SCHWA
CTLSWB          equ     $283    ;I/O Control for SCHWB

count           equ     $40
dliv            equ     $41

from			equ		$43
to				equ		$45

shscrol			equ		$47


postab			equ		$1900


ROMTOP   		ORG   $4000 

fontdata:		incbin armfont.raw

WaitVBLANK:
WaitVBoff:
                bit     MSTAT  
                bmi     WaitVBoff
WaitVBon:
                bit     MSTAT
                bpl     WaitVBon
                rts

START
	sei                     ;Disable interrupts
	cld                     ;Clear decimal mode
	
;******** Atari recommended startup procedure

	lda     #$07
	sta     INPTCTRL        ;Lock into 7800 mode
	lda     #$7F
	sta     CTRL
        sta     BACKGRND            ;Disable DMA
	lda     #$00            
	sta     OFFSET
	sta     INPTCTRL
        sta     count
	ldx     #$FF            ;Reset stack pointer
	txs

        lda     #>fontdata      ;the font data is located at $5000
        sta     CHARBASE          ;
		
		lda		#3
		sta		shscrol			;default scroll

        lda     #$0f			;colors boss
        sta     P0C1
        lda     #$2a
        sta     P0C2
        lda     #$a4
        sta     P0C3

		lda     #$0f			;colors bub
        sta     P1C1
        lda     #$8a
        sta     P1C2
        lda     #$22
        sta     P1C3
		
		lda     #$0f			;colors guard
        sta     P2C1
        lda     #$3a
        sta     P2C2
        lda     #$32
        sta     P2C3

		lda     #$0f			;colors yoshi
        sta     P3C1
        lda     #$aa
        sta     P3C2
        lda     #$f4
        sta     P3C3
	
		lda     #$0f			;colors chicken
        sta     P4C1
        lda     #$5a
        sta     P4C2
        lda     #$22
        sta     P4C3
		
		lda     #$0f			;colors yoshi baby #1
        sta     P5C1
        lda     #$f4
        sta     P5C2
        lda     #$6a
        sta     P5C3
		
		lda     #$0f			;colors yoshi baby #2
        sta     P6C1
        lda     #$f4
        sta     P6C2
        lda     #$7a
        sta     P6C3

		lda     #$0f	;font colours
        sta     P7C1
        lda     #$92
        sta     P7C2
        lda     #$94
        sta     P7C3

                ldx     #$00
CopyLoop:
                lda     $e000,x
                sta     $1800,x
                inx
                bne     CopyLoop

                lda     #<DLList
                sta     DPPL    	        ;setup the pointers for the output
                lda     #>DLList         	; description (DLL) according to
                sta     DPPH          
                jsr     WaitVBLANK      ;wait until no DMA would happen

                lda     #$40
                sta     CTRL
                lda     #$00
                sta     BACKGRND
				jsr 	tabinit			;inits sprite_position tables
				
loop	
        jsr     WaitVBLANK
		jsr		scroll					;move scroller
		
        ldx     #0
		ldy		postab,x
        lda     $c000,y					;swing the scroller
        clc
        adc		#32
        lsr								;div 2
        lsr								;div 4
		lsr
;		lsr
        and		#$0f
       	sta		bounce
       	lda		$c000,y
        clc
        adc 	#32
        sta     dl_logo_1+3
 		sta		dl_logo_2+3
 		inx
 		ldy		postab,x
 		lda		$c000,y
 		clc		
 		adc 	#32
 		sta		dl_logo_1+7
 		sta		dl_logo_2+7
        inx
 		ldy		postab,x
 		lda		$c000,y
 		clc
 		adc 	#32
 		sta		dl_logo_1+11
 		sta		dl_logo_2+11
        clc
        adc		#32
        inx
 		ldy		postab,x
 		lda		$c000,y
 		clc
 		adc		#32
 		sta		dl_logo_1+15
 		sta		dl_logo_2+15
        inx
 		ldy		postab,x
 		lda		$c000,y
 		clc
 		adc		#32
 		sta		dl_logo_1+19
 		sta		dl_logo_2+19
        inx
 		ldy		postab,x
 		lda		$c000,y
 		clc
 		adc		#32
 		sta		dl_logo_1+23
 		sta		dl_logo_2+23
        inx
 		ldy		postab,x
 		lda		$c000,y
 		clc
 		adc		#32
 		sta		dl_logo_1+27
 		sta		dl_logo_2+27
 	    inx
 		ldy		postab,x
 		lda		$c000,y
 		clc
 		adc		#32
 		sta		dl_logo_1+31
 		sta		dl_logo_2+31
  
 		
 		ldx #7
loop2	inc		postab,x
 		dex
 		bpl		loop2
		
		jmp     loop

scroll	dec shscrol
		beq	scroller0
		inc	DLscroller+4
		inc DLscroller+9
		rts
scroller0 lda #3
		sta shscrol
		lda #0
		sta DLscroller+4
		lda #128
		sta DLscroller+9
		inc DLscroller
		lda DLscroller
		clc
		adc #32
		sta DLscroller+5
		rts
		


tabinit	lda #0
		ldx #7		;8 sprites
tabinit0 sta postab,x
		clc
		adc #24
		dex
		bpl	tabinit0
		rts
NMI
;        jmp    (dliv)
	RTI
	
IRQ
	RTI

                ORG     $a000
                incbin  sprites.raw

sintab
                ORG     $c000
                incbin  SINTAB.BIN

line1           .byte   "    HEAVEN OF TAQUART    "

scrolltext		.byte "WELCOME TO MY FIRST ATARI DEMO ON THIS CONSOLE  "
				.byte "WELCOME TO MY FIRST ATARI DEMO ON THIS CONSOLE  "
				.byte "WELCOME TO MY FIRST ATARI DEMO ON THIS CONSOLE  "
				.byte "WELCOME TO MY FIRST ATARI DEMO ON THIS CONSOLE  "
				.byte "WELCOME TO MY FIRST ATARI DEMO ON THIS CONSOLE  "
				.byte "WELCOME TO MY FIRST ATARI DEMO ON THIS CONSOLE  "
				.byte "WELCOME TO MY FIRST ATARI DEMO ON THIS CONSOLE  "				
				.byte "WELCOME TO MY FIRST ATARI DEMO ON THIS CONSOLE  "
				.byte "WELCOME TO MY FIRST ATARI DEMO ON THIS CONSOLE  "
				
; This contains the text data, several DLs and the DLL.
; It gets copied to the RAM at $1800 for DMA timing reasons.
                ORG     $e000
                RORG	$1800
                ALIGN   16
DLBlank:
                .byte   $00,$00

DLLine1:
                .byte   <line1,$60,>line1,$e6,72
                .byte   $00,$00
                Align   8

DLscroller:
                .byte   <scrolltext,$60,>scrolltext,$40,0
				.byte	<scrolltext+32,$60,>scrolltext,$50,128
                .byte   $00,$00
                Align   8


;logo 2 zones, each font has 32x32 pixel = 8x32 bytes

                Align 8                         ;$1830
dl_logo_1       .byte   $00,$18,$a0,$00     	;Boss
				.byte	$08,$3c,$a0,$20			;Bub
				.byte 	$10,$58,$a0,$40			;Guard
				.byte 	$18,$7a,$a0,$60			;Yoshi
				.byte 	$0c,$9c,$a0,$80			;chicken
				.byte 	$22,$bc,$a0,$a0			;yoshi baby #1
				.byte	$26,$dc,$a0,$c0			;yoshi baby #2
				.byte	$2a,$7c,$a0,$e0			;yoshi baby #3
                .byte   $00,$00
;2nd half
                Align 	40                        ;$1850
dl_logo_2       .byte   $00,$18,$b0,$00     	;Boss
				.byte	$08,$3c,$b0,$20			;Bub
				.byte 	$10,$58,$b0,$40			;Guard
				.byte 	$18,$7a,$b0,$60			;Yoshi
				.byte 	$0c,$9c,$b0,$80			;chicken
				.byte 	$22,$bc,$b0,$a0			;yoshi baby #1
				.byte	$26,$dc,$b0,$c0			;yoshi baby #2
                .byte	$2a,$7c,$b0,$e0			;yoshi baby #3
                .byte   $00,$00

; The DLL starts here - $1870
                Align   32
DLList          .byte   $07,>DLBlank,<DLBlank  
		        .byte   $07,>DLBlank,<DLBlank  
		        .byte   $07,>DLBlank,<DLBlank  
		        .byte   $07,>DLBlank,<DLBlank  
        		.byte   $07,>DLBlank,<DLBlank  
        		.byte   $07,>DLBlank,<DLBlank  
        		.byte   $07,>DLBlank,<DLBlank  
        		.byte   $07,>DLBlank,<DLBlank  
        		.byte   $07,>DLBlank,<DLBlank  
        		.byte   $07,>DLBlank,<DLBlank  
        		.byte   $07,>DLBlank,<DLBlank  
 
;logo

                .byte   $0f,>dl_logo_2,<dl_logo_2		;upper part of the gfx
                .byte   $0e,>dl_logo_1,<dl_logo_1		;lower part of the gfx
                .byte   $07,>DLLine1,<DLLine1			;status
               	.byte   $07,>DLBlank,<DLBlank  
        		.byte   $07,>DLBlank,<DLBlank  
        		.byte   $07,>DLBlank,<DLBlank  
               	.byte   $07,>DLBlank,<DLBlank  
        		.byte   $07,>DLBlank,<DLBlank  
        		.byte   $07,>DLBlank,<DLBlank  
   				.byte   $07,>DLBlank,<DLBlank  
        		.byte   $07,>DLBlank,<DLBlank  
bounce			.byte	$0f,>DLBlank,<DLBlank			;buffer for bouncing   
   
                .byte   $07,>DLscroller,<DLscroller		;scroll-text
				.byte   $07,>DLBlank,<DLBlank  
        		.byte   $07,>DLBlank,<DLBlank    
        		
 
                .byte   $00,>DLBlank,<DLBlank			;end of DLL



;************** Cart reset vector **************************

	 org     $fff8
	.byte   $FF         ;Region verification
	.byte   $47         ;ROM start $4000
	.word   #NMI
	.word   #START
	.word   #IRQ

